Summary: Printer Application Framework (PAPPL)
Name: pappl-retrofit
Version: 1.0b2
Release: 1%{?dist}
License: Apache-2.0-with-GPL2-LGPL2-Exception
Source: https://github.com/OpenPrinting/pappl-retrofit/releases/download/%{version}/pappl-retrofit-%{version}.tar.xz
Url: https://github.com/OpenPrinting/pappl-retrofit

BuildRequires: avahi-devel
BuildRequires: cups-devel
BuildRequires: gcc
BuildRequires: git-core
BuildRequires: glibc-devel
BuildRequires: libppd-devel
BuildRequires: pappl-devel
BuildRequires: make
BuildRequires: pkgconfig

%description
Description: Library to turn classic CUPS drivers into Printer Applications
pappl-retrofit is a simple C-based framework/library for converting classic
CUPS printer drivers into Printer Applications.

From CUPS 3.x on (release end-2023) and already now with the CUPS
Snap classic CUPS drivers consisting of PPD and filters are not
supported any more. CUPS itself only supports driverless IPP printers
then and Printer Applications are emulations of driverless IPP printers.

This package provides the library containing all the needed functionality.


%package devel
Summary: PAPPL - development environment
Requires: %{name}%{?_isa} = %{version}-%{release}

BuildRequires: pappl-devel

%description devel
This package provides the pappl-retrofit headers and development environment.


%package -n legacy-printer-app
Summary: Legacy Printer Application - Make classic drivers available
Requires: %{name}%{?_isa} = %{version}-%{release}

%description -n legacy-printer-app
If the system is using the CUPS Snap or CUPS 3.x the Legacy Printer
Application makes classically installed CUPS drivers available as
emulation of a driverless IPP printer, as they were part of the
Printer Application.

The driver simply needs to get installed to the places where CUPS would
expect it, so an installed Fedora package of a CUPS driver for example
would work.

This is the easiest way to conserve proprietary printer drivers which
cannot get freely re-built, re-packaged and re-distributed.

%prep
%autosetup -S git

%build
export DSOFLAGS="$DSOFLAGS -Wl,-z,now,--as-needed"
#need this to enable build with '-D_FILE_OFFSET_BITS=64' flag
export CPPFLAGS="$CPPFLAGS -D_FILE_OFFSET_BITS=64"
%configure --enable-legacy-printer-app-as-daemon \
  --enable-pappl-backends-for-legacy-printer-app
%make_build

%install
%make_install BUILDROOT=%{buildroot}
# Removal of the static library and libtool archive.
rm -f %{buildroot}/%{_libdir}/libpappl-retrofit.a
rm -f %{buildroot}/%{_libdir}/libpappl-retrofit.la

rm -f %{buildroot}/%{_libdir}/legacy-printer-app
ln -s cups %{buildroot}/%{_exec_prefix}/lib/legacy-printer-app

%check
#make test

%files
%{_libdir}/libpappl-retrofit.so.*
%doc *.md
%license LICENSE NOTICE

%files devel
%doc %{_docdir}/pappl-retrofit/*
%{_includedir}/*.h
%{_libdir}/libpappl-retrofit.so
%{_libdir}/pkgconfig/libpappl-retrofit.pc

%files -n legacy-printer-app
%{_sbindir}/*
%dir %{_datadir}/legacy-printer-app
%{_datadir}/legacy-printer-app/*
%{_exec_prefix}/lib/legacy-printer-app
%attr(0644, root, root)%{_unitdir}/legacy-printer-app.service
%dir %attr(0710,root,lp) %{_localstatedir}/lib/legacy-printer-app
%dir %attr(0710,root,lp) %{_localstatedir}/spool/legacy-printer-app

%changelog
* Sun Mar 19 2023 Douglas Kosovic <doug@uq.edu.au> - 1.0b2-1
- Initial version of package

